script_name("")
script_author("Cosmo")

local se = require "samp.events"

--  
local last = {}
local markers = {}
local timer_marker = 10000 --  ( .)   

--    
local analysis = false --    
local last_text = nil --     
local cooldown = 250 --  ( .)    
local prices = {} --     

local path_json = getWorkingDirectory() .. "\\config\\ab_prices.json"
if not doesFileExist(path_json) then
	createDirectory(getWorkingDirectory() .. "\\config\\")
	local file = io.open(path_json, "w")
	file:write(encodeJson(prices))
	file:close()
else
	local file = io.open(path_json, "r")
	prices = decodeJson(file:read("*a"))
	file:close()
end

function main()
	assert(isSampLoaded(), "SA:MP was not loaded!")
	while not isSampAvailable() do wait(0) end

	sampRegisterChatCommand('carprice', function(search)
		search = to_lower(search)
		if search ~= nil then
			local result = false
			for _, vehicle in ipairs(prices) do
				if string.find(to_lower(vehicle.name), search, 1, true) then
					if result == false then
						sampAddChatMessage("[] {FFFFFF} :", 0xFF6060)
						result = true
					end

					local price = sum_format(vehicle.price)
					pirce = price and string.format("%s$", price) or ""
					sampAddChatMessage(string.format(" > {FFFFFF}: {FF6060}%s{FFFFFF},  : {FF6060}%s", vehicle.name, pirce), 0xFF6060)
				end
			end

			if result == false then
				sampAddChatMessage("[] {FFFFFF}     !", 0xFF6060)
			end
			return
		end
		sampAddChatMessage("[] {FFFFFF}: /carprice [    ]", 0xFF6060)
	end)

	sampRegisterChatCommand("ab", function()
		analysis = not analysis
		if analysis then
			last_text = nil
			sampAddChatMessage("[] {FFFFFF}     ", 0xFF6060)
			sampAddChatMessage("[] {FFFFFF}        ALT", 0xFF6060)
		else
			sampAddChatMessage("[] {FFFFFF}    ", 0xFF6060)
		end
	end)
	wait(-1)
end

function se.onShowDialog(id, style, title, but_1, but_2, text)
	if analysis then
		if string.find(title, "    ") then
			local count = 0
			if last_text == nil then
				writeMessage("  .     ..")
				backup = prices
				prices = {}
			end

			if last_text == text then
				writeMessage("    .   {FF6060}%s{FFFFFF} /", #prices)
				sampSendDialogResponse(id, 0, nil, nil)
				analysis = false

				local file = io.open(path_json, "w")
				file:write(encodeJson(prices))
				file:close()

				goto finish
			else
				last_text = text
			end

			for line in string.gmatch(text, "[^\n]+") do
				count = count + 1
				if count >= 4 then
					local vehicle, price = line:match("^(.+)\t%$(%d+)$")
					price = tonumber(price)
					if vehicle and price then
						table.insert(prices, {
							name = vehicle,
							price = price
						})
					end
				end
			end

			lua_thread.create(function()
				wait(cooldown)
				sampSendDialogResponse(id, 1, 1, nil)
			end);

			::finish::
			return false
		else
			for i, vehicle in ipairs(backup) do
		        table.insert(prices, { vehicle.name, vehicle.price })
		    end
		    backup = nil
		    analysis = false
		    writeMessage("     !  !")
		end
	elseif string.find(title, "    ") then
		writeMessage("   /    , :")
		writeMessage("    ")
		writeMessage("     /ab")
		writeMessage("        ")
	end

	if id == 9837 and string.find(title, "  ") then
		text = string.gsub(text, "%$(%d+)", function(arg) return "$" .. tostring(sum_format(arg)) end)
		text = string.gsub(text, "(%d+)%$", function(arg) return tostring(sum_format(arg)) .. "$" end)
		if #prices > 0 then
			local vehicle = string.match(text, ": {%x+}(.+)%[%d+%]")
			if vehicle ~= nil then
				local price = " "
				for _, veh in ipairs(prices) do
					if vehicle == veh.name then
						price = string.format("%s$", sum_format(veh.price))
						break
					end
				end
				text = string.gsub(text, "$", "\n{6DBE55} : " .. price)
			end
		end
		return { id, style, title, but_1, but_2, text }
	end
end

function se.onSetObjectMaterialText(id, data)
	local object = sampGetObjectHandleBySampId(id)
	if object and doesObjectExist(object) then
		if getObjectModel(object) == 18663 then
			if string.find(data.text, ": [A-z0-9_]+") then
				last = {
					vehicle = nil,
					price = nil,
					tuning = nil
				}

				local tuning = string.match(data.text, "\n\n\n([^\n]+)\n\n: [A-z0-9_]+\n{%x+}id: %d+")
				if tuning and last ~= nil then
					last.tuning = string.gsub(tuning, "{%x+}", "")
				end
			end
			
			local vehicle, color, price = string.match(data.text, "([^\n]+)\n({%x+})%$(%d+)")
			if vehicle and color and price and last ~= nil then
				last.vehicle = vehicle
				last.price = sum_format(price)
				data.text = string.format("%s\n%s$%s\n\n\n\n", last.vehicle, color, last.price)

				if isCharInArea2d(PLAYER_PED, -2113.40, -860.00, -2154.30, -744.65, false) then
					local _, x, y, z = getObjectCoordinates(object)
					local n = #markers + 1
					markers[n] = createUser3dMarker(x, y, z + 2, 0)
					lua_thread.create(function()
						wait(timer_marker)
						removeUser3dMarker(markers[n])
						markers[n] = nil
					end)

					writeMessage("   {FF6060}%s%s{FFFFFF}  {FF6060}$%s", last.vehicle, last.tuning and " [{FFFFFF}" .. last.tuning .. "{FF6060}]" or "", last.price)
					if #prices > 0 then
						local average_cost = " "
						for _, vehicle in ipairs(prices) do
							if vehicle.name == last.vehicle then
								average_cost = string.format("$%s", sum_format(vehicle.price))
								break
							end
						end
						writeMessage(" : {FF6060}%s", average_cost)
					end
				end

				return { id, data }
			end
		end
	end
end

function writeMessage(format, ...)
	local message = string.format(format, ...)
	return sampAddChatMessage(string.format("[%s]{FFFFFF} %s", thisScript().name, message), 0xFF6060)
end

function sum_format(sum)
	sum = tostring(sum)
	if sum ~= nil and #sum > 3 then
		local b, e = ('%d'):format(sum):gsub('^%-', '')
		local c = b:reverse():gsub('%d%d%d', '%1.')
		local d = c:reverse():gsub('^%.', '')
		return (e == 1 and '-' or '')..d
	end
	return sum
end

function to_lower(str)
	if type(str) ~= "string" then
		return nil
	end
	for i = 192, 223 do
		str = str:gsub(_G.string.char(i), _G.string.char(i + 32))
	end
	str = str:gsub(_G.string.char(168), _G.string.char(184))
	return str:lower()
end

function onScriptTerminate(script, quit)
	if script == thisScript() then
		for i, marker in pairs(markers) do
			removeUser3dMarker(marker)
			markers[i] = nil
		end
	end
end